package org.wfc.omada.api.device.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * AutoCheckUpgradeCreateInfo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:26:25.576+08:00[Asia/Shanghai]")

public class AutoCheckUpgradeCreateInfo   {
  @JsonProperty("modelTypeInfos")
  @Valid
  private List<ModelTypeInfoOpenApiVo> modelTypeInfos = new ArrayList<>();

  @JsonProperty("siteIds")
  @Valid
  private List<String> siteIds = new ArrayList<>();

  @JsonProperty("occurrence")
  private UpgradeBaseScheduleTimeOpenApiVo occurrence;

  @JsonProperty("channel")
  private Integer channel;

  public AutoCheckUpgradeCreateInfo modelTypeInfos(List<ModelTypeInfoOpenApiVo> modelTypeInfos) {
    this.modelTypeInfos = modelTypeInfos;
    return this;
  }

  public AutoCheckUpgradeCreateInfo addModelTypeInfosItem(ModelTypeInfoOpenApiVo modelTypeInfosItem) {
    this.modelTypeInfos.add(modelTypeInfosItem);
    return this;
  }

  /**
   * List of model type selected by the user, and it should not be null
   * @return modelTypeInfos
  */
  @ApiModelProperty(required = true, value = "List of model type selected by the user, and it should not be null")
  @NotNull

  @Valid

  public List<ModelTypeInfoOpenApiVo> getModelTypeInfos() {
    return modelTypeInfos;
  }

  public void setModelTypeInfos(List<ModelTypeInfoOpenApiVo> modelTypeInfos) {
    this.modelTypeInfos = modelTypeInfos;
  }

  public AutoCheckUpgradeCreateInfo siteIds(List<String> siteIds) {
    this.siteIds = siteIds;
    return this;
  }

  public AutoCheckUpgradeCreateInfo addSiteIdsItem(String siteIdsItem) {
    this.siteIds.add(siteIdsItem);
    return this;
  }

  /**
   * List of sites selected by the user, and it should not be null
   * @return siteIds
  */
  @ApiModelProperty(required = true, value = "List of sites selected by the user, and it should not be null")
  @NotNull


  public List<String> getSiteIds() {
    return siteIds;
  }

  public void setSiteIds(List<String> siteIds) {
    this.siteIds = siteIds;
  }

  public AutoCheckUpgradeCreateInfo occurrence(UpgradeBaseScheduleTimeOpenApiVo occurrence) {
    this.occurrence = occurrence;
    return this;
  }

  /**
   * Get occurrence
   * @return occurrence
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull

  @Valid

  public UpgradeBaseScheduleTimeOpenApiVo getOccurrence() {
    return occurrence;
  }

  public void setOccurrence(UpgradeBaseScheduleTimeOpenApiVo occurrence) {
    this.occurrence = occurrence;
  }

  public AutoCheckUpgradeCreateInfo channel(Integer channel) {
    this.channel = channel;
    return this;
  }

  /**
   * Channel should be a value as follows: 0: stable; 1: Release Candidate(RC); 2: Beta, and it should not be null
   * @return channel
  */
  @ApiModelProperty(required = true, value = "Channel should be a value as follows: 0: stable; 1: Release Candidate(RC); 2: Beta, and it should not be null")
  @NotNull


  public Integer getChannel() {
    return channel;
  }

  public void setChannel(Integer channel) {
    this.channel = channel;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AutoCheckUpgradeCreateInfo autoCheckUpgradeCreateInfo = (AutoCheckUpgradeCreateInfo) o;
    return Objects.equals(this.modelTypeInfos, autoCheckUpgradeCreateInfo.modelTypeInfos) &&
        Objects.equals(this.siteIds, autoCheckUpgradeCreateInfo.siteIds) &&
        Objects.equals(this.occurrence, autoCheckUpgradeCreateInfo.occurrence) &&
        Objects.equals(this.channel, autoCheckUpgradeCreateInfo.channel);
  }

  @Override
  public int hashCode() {
    return Objects.hash(modelTypeInfos, siteIds, occurrence, channel);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AutoCheckUpgradeCreateInfo {\n");
    
    sb.append("    modelTypeInfos: ").append(toIndentedString(modelTypeInfos)).append("\n");
    sb.append("    siteIds: ").append(toIndentedString(siteIds)).append("\n");
    sb.append("    occurrence: ").append(toIndentedString(occurrence)).append("\n");
    sb.append("    channel: ").append(toIndentedString(channel)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

